#!/usr/bin/python

import urllib
import Classes
from xml.etree import ElementTree as ET
from user import home
import os
import apt
import commands
import gtk
import gtk.glade
import pygtk
import sys
import threading
import gettext
pygtk.require("2.0")

cache = apt.Cache()
model = Classes.Model()	
del model.portals[:]
portalsFile = open("usr/share/linuxmint/mintinstall/portals.list")
for line in portalsFile:
	array = line.split(";")
	if len(array) == 6:
		portal = Classes.Portal(array[0], array[1], array[2], array[3], array[4], array[5])
		model.portals.append(portal)
portalsFile.close()

os.system("mkdir -p usr/share/linuxmint/mintinstall/data")
os.system("rm -rf usr/share/linuxmint/mintinstall/data/*")
os.chdir("usr/share/linuxmint/mintinstall/data")
os.system("mkdir -p ./icons/categories")
os.system("mkdir -p ./mintfiles")
os.system("mkdir -p ./screenshots")
os.system("mkdir -p ./xml")
os.system("mkdir -p ./details")
packagesFile = open("./details/packages.list", "w")

for portal in model.portals:
	portal.update_url = portal.update_url.strip()
	webFile = urllib.urlopen(portal.update_url)
	print portal.update_url	
	localFile = open("./xml/" + portal.key + ".xml", 'w')
	localFile.write(webFile.read())
	webFile.close()
	localFile.close()

num_apps = 0

for portal in model.portals:
	fileName = "./xml/" + portal.key + ".xml"
	numItems = commands.getoutput("grep -c \"<item\" " + fileName)
	numReviews = commands.getoutput("grep -c \"<review\" " + fileName)
	numScreenshots = commands.getoutput("grep -c \"<screenshot\" " + fileName)
	numCategories = commands.getoutput("grep -c \"<category\" " + fileName)
	numTotal = int(numItems) + int(numReviews) + int(numScreenshots) + int(numCategories)
	processed_categories = 0
	processed_items = 0
	processed_screenshots = 0
	processed_reviews = 0			
	processed_total = 0
	xml = ET.parse(fileName)
	root = xml.getroot()				
	for element in root: 
		if element.tag == "category":
			category = Classes.Category(portal, element.attrib["id"], element.attrib["name"], element.attrib["description"], element.attrib["vieworder"], element.attrib["parent"], element.attrib["logo"])				
			category.name = category.name.replace("ANDAND", "&")
			os.chdir("./icons/categories")	
			os.system("wget -nc -O" + category.key + " " + category.logo)
			os.chdir("../..")					
			category.logo = gtk.gdk.pixbuf_new_from_file_at_size("./icons/categories/" + category.key, 16, 16)
			portal.categories.append(category)			
			processed_categories = int(processed_categories) + 1	
			processed_total = processed_total + 1
				
		elif element.tag == "item":
			item = Classes.Item(portal, element.attrib["id"], element.attrib["link"], element.attrib["mint_file"], element.attrib["category"], element.attrib["name"], element.attrib["description"], element.attrib["added"], element.attrib["views"], element.attrib["license"], element.attrib["size"], element.attrib["website"], element.attrib["repository"], element.attrib["average_rating"])
			item.average_rating = int((float(item.average_rating) - float(1)) / float(4) * float(100))
			item.views = int(item.views)
			item.link = item.link.replace("ANDAND", "&")
			os.chdir("./mintfiles")	
			os.system("wget -nc -O" + item.key + ".mint -T10 \"" + item.mint_file + "\"")
			os.chdir("..")
			item.mint_file = "./mintfiles/" + item.key + ".mint"

			packages = []
			repositories = []
			is_special = False
			if os.path.exists(item.mint_file):	
				directory = "/tmp/mintinstall-data"		
				os.system("mkdir -p " + directory)
				os.system("rm -rf " + directory + "/*") 
				os.system("cp " + item.mint_file + " " + directory + "/file.mint")
				os.system("tar zxf " + directory + "/file.mint -C " + directory)
				steps = int(commands.getoutput("ls -l " + directory + "/steps/ | wc -l"))
				steps = steps -1				
				for i in range(steps + 1):
					if (i > 0):			
						openfile = open(directory + "/steps/"+str(i), 'r' )
						datalist = openfile.readlines()
						for j in range( len( datalist ) ):
						    if (str.find(datalist[j], "INSTALL") > -1):
							install = datalist[j][8:]
							install = str.strip(install)
							packages.append(install)
						    if (str.find(datalist[j], "SOURCE") > -1):
							source = datalist[j][7:]
							source = source.rstrip()
							repositories.append(source)	
						    if (str.find(datalist[j], "EXECUTE") > -1):
							execute = datalist[j][8:]
							execute = execute.rstrip()
							is_special = True						
						openfile.close()

				if (not is_special) and len(repositories) == 0 and len(packages) > 0:
					string = item.key
					for package in packages:
						string = string + " " + package
					packagesFile.writelines(string + "\n")

			if item.repository == "":
				item.repository = "Default repositories"
			portal.items.append(item)		
			portal.find_category(item.category).add_item(item)			
			processed_items = int(processed_items) + 1	
			processed_total = processed_total + 1

		elif element.tag == "screenshot":
			screen_item = element.attrib["item"]
			screen_img = element.attrib["img"]
			item = portal.find_item(screen_item)
			if item != None:			
				try:
					os.chdir("./screenshots")	
					#os.system("wget -nc -O" + screen_item + " -T10 \"" + screen_img + "\"")
					os.chdir("..")
					item.screenshot = "./screenshots/" + screen_item
					item.screenshot_url = screen_img													
					processed_screenshots = int(processed_screenshots) + 1	
				except:
					pass
			processed_total = processed_total + 1

		elif element.tag == "review":
			item = portal.find_item(element.attrib["item"])
			if (item != None):
				review = Classes.Review(portal, item, element.attrib["rating"], element.attrib["comment"], element.attrib["user_id"], element.attrib["user_name"])
				if "@" in review.username:
					elements = review.username.split("@")
					firstname = elements[0]
					secondname = elements[1]
					firstname = firstname[0:1] + "..." + firstname [-2:-1]
					review.username = firstname + "@" + secondname
				item.add_review(review)
				portal.reviews.append(review)				
				processed_reviews = int(processed_reviews) + 1	

			processed_total = processed_total + 1
	num_apps = num_apps + len(portal.items)

packagesFile.flush()
packagesFile.close()

# Reconciliation of categories hierarchy
for portal in model.portals:
	for category in portal.categories:
		if (category.parent == "0"):
			category.parent = None
		else:
			parentKey = category.parent			
			parent = portal.find_category(parentKey)
			parent.add_subcategory(category)
			
